--[[
  * Author: Zen
  * Purpose: Officer Tools
  * Portions taken from Wykkyd's [ Mail Box ] - which unfortunately broke during a patch upgrade
  * Sponsored & Supported by: Mostly Harmless (mostly-harmless-guild.com)
  * Author: Wykkyd, aka Wykkyd Gaming (wykkyd.gaming@gmail.com) (mailbox handling)
  * Embedded: LibStub & libAddonMenu by Seerah.
  * Special Thanks To: Zenimax Online Studios & Bethesda for The Elder Scrolls Online
]]--

function call_later( delay ) zo_callLater( xoCOGlateEcho, delay ) end

local debug_data = ""
local cpxp = 0
local starttime = 0
local baseLine = 0
local lastRank = 0
local criticalMass = 0
local moveWinActive = 0

local cxp_base = 0
local cpxpmax = 0
local last_cpxp = 0
local cpxp_tot = 0
local lastCurXP = 0
local lastCXPhr = 0

local _addon = {}
_addon._v = {}
_addon._v.major		= 1
_addon._v.monthly 	= 0
_addon._v.daily 	= 1 --27
_addon._v.minor 	= 22 --1
_addon.Version 	= _addon._v.major
	..".".._addon._v.monthly
	..".".._addon._v.daily
	..".".._addon._v.minor
_addon.Name			= "ChampionXP"
_addon.MAJOR 		= _addon.Name..".".._addon._v.major
_addon.MINOR 		= string.format(".%02d%02d%03d", _addon._v.monthly, _addon._v.daily, _addon._v.minor)
_addon.DisplayName  = "ChampionXP"
_addon.Author 		= "Zen @ The Crimson Order"
_addon.AuthorShort 	= "Zen"
_addon.SavedVariableVersion = 1
_addon.Player = "" -- will be set on load by LibWykkkydFactory
_addon.Settings = {} -- will be set on load by LibWykkkydFactory, if you pass in the final parameter: your global saved variable as a string
_addon.GlobalSettings = {} -- will be set on load by LibWykkkydFactory, if you pass in the final parameter: your global saved variable as a string
_addon.wykkydPreferred = nil
_addon.moveWinActive = false

function ChampionXPEarnedMoveStop()
	_addon.Settings.windowLeft = CHAMPIONXP:GetLeft()
	_addon.Settings.windowTop = CHAMPIONXP:GetTop()
	_addon.moveWinActive = false
	d( "CXP window is now fixed in place" )
end

_addon.LoadSavedVariables = function( self )
	if self.Settings.windowTop == nil then self.Settings.windowTop = CHAMPIONXP:GetTop() end
	if self.Settings.windowLeft == nil then self.Settings.windowLeft = CHAMPIONXP:GetLeft() end
	_addon.moveWindow( self.Settings.windowTop, self.Settings.windowLeft )
end

_addon.moveWindow = function( top, left )
	CHAMPIONXP:SetAnchor( TOPLEFT, GuiRoot, TOPLEFT, left, top )
end

_addon.LoadSettingsMenu = function( self )
	local panelData = self:MakeStandardSettingsPanel( "Zen @ The Crimson Order", "|cFF2222" )
	local optionsTable = {
		[1] = { type = "submenu", name = "|cFFFFFF".."Chat Commands".."|r",
			controls = {
				[1] = {
					type = "description",
					text = self.helpText()
				},
				[2] = {
					type = "description",
					text = "Note that if you use the /cxpmove command, the CXP display will remain visible until you have moved it"
				},
			},
		},

	}
	optionsTable = self:InjectAdvancedSettings( optionsTable, 1 )
	self.LAM:RegisterAddonPanel(_addon.Name.."_LAM", panelData)
	self.LAM:RegisterOptionControls(_addon.Name.."_LAM", optionsTable)
end

_addon.converthm = function(timesec)
	timesec = timesec%86400
	local nb_heure = math.floor(timesec/3600)
	local reste = timesec - (nb_heure*3600)
	local nb_minute = math.floor(reste/60)
	return string.format("(%02d:%02d)", nb_heure, nb_minute)
end

_addon.PlayerActivated = function()
	EVENT_MANAGER:UnregisterForEvent( _addon.Name, EVENT_PLAYER_ACTIVATED )
	cpxp = GetPlayerChampionXP()
	cxp_base = cpxp
	-- cpxpmax = GetUnitChampionPoints(GetPlayerChampionPointsEarned())
	cpxpmax = GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned())
	starttime = GetTimeStamp()
	if IsChampionSystemUnlocked() then
		_addon.sceneSystem = SCENE_MANAGER.scenes.hud
		_addon.sceneSystem:RegisterCallback("StateChange", 
			function( oldState, newState )
				-- d( oldState..", "..newState..", "..SCENE_MANAGER.currentScene.name )
				if oldState == "showing" then
					_addon.guiShown()
				elseif not _addon.moveWinActive then
					_addon.guiHidden()
				end
			end
		)
		EVENT_MANAGER:RegisterForUpdate( "ChampionXP", 5000, _addon.updateCPXPWin2 )
		-- EVENT_MANAGER:RegisterForEvent( _addon.Name, EVENT_CHAMPION_POINT_GAINED, self.updateCPXPWin )
		_addon.updateCPXPWin2()
	end
end


_addon.guiShown = function()
	local x = _addon.Settings.windowLeft
	local y = _addon.Settings.windowTop
	_addon.moveWindow( y, x )
	CHAMPIONXP:SetAlpha(1.0)
end

_addon.guiHidden = function()
	local x = _addon.Settings.windowLeft
	local y = _addon.Settings.windowTop
	_addon.moveWindow( y - 1000, x + 1000 )
	CHAMPIONXP:SetAlpha(0.0)
end

local didIt = 0

_addon.updateCPXPWin2 = function()
	local curtime = GetTimeStamp() - starttime
	local ct = "(00:00)"
	local pc = 0
	local cvg = 0
	local xavg = 0
	local curXP = 0
	local ctot = GetPlayerChampionXP()

	if ctot < 1 then return end

	if cpxpmax == 0 then
		cpxpmax = GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned())
	end
	if ctot < last_cpxp then
		cpxp_tot = cpxp_tot + (cpxpmax-cxp_base);
		cxp_base = 0
		cpxpmax = GetNumChampionXPInChampionPoint(GetPlayerChampionPointsEarned())
	end
	last_cpxp = ctot
	curXP = (ctot + cpxp_tot) - cxp_base

	avg = curXP
	xavg = avg

	if curtime > 0 then
		ct = _addon.converthm( curtime )
		if curtime > 3600 and curXP > 0 then
			hrs = curtime/3600
			avg = curXP/hrs
			xavg = avg
			avg = string.format("%d", avg )
		end
	end
	if cpxpmax == nil then cpxpmax = 0 end
	if ctot > 0 and cpxpmax > 0 then
		local tot = cpxpmax/100
		pc = ctot/tot
		-- pc = pc/curXP
		pc = string.format("%.2f", pc )
	end
	if xavg > 999 then avg = _addon:comma_value( avg ) end
	local cp1 = GetNumUnspentChampionPoints( 1 ) -- steed
	local cp2 = GetNumUnspentChampionPoints( 3 ) -- atronach
	local cp3 = GetNumUnspentChampionPoints( 2 ) -- apprentice
	local cp4 = GetPlayerChampionPointsEarned() -- total CP
	if cp4 > 0 then cp4 = _addon:comma_value( cp4 ) end
	local ucp = "|cD6660C"..cp1.."  |c0dab36"..cp2.."  |c1970c9"..cp3
	local data1 = "CXP earned:\nCXP/hr:\nEnlightenment:\nUnspent CP:"
	local data2 = _addon:comma_value( curXP ).."\n"..avg
	local pool = GetEnlightenedPool()
	local poolText = "0"
	if pool > 0 then
		poolText = _addon:comma_value( pool )
	end
	data2 = data2.."\n"..poolText.."\n"..ucp

	CHAMPIONXPDisplayLeft:SetText( data1 )
	CHAMPIONXPDisplayCenter:SetText( data2 )
	CHAMPIONXPDisplayRight:SetText( " ".._addon:comma_value( pc ).."%\n"..ct.."\n \n ("..cp4..")" )

	lastCurXP = curXP
	lastCXPhr = avg

end

_addon.splitString = function(inputstr, sep)
	if inputstr == nil then 
		return nil 
	end
   	if sep == nil then
            sep = "%s"
    end
    local t={} ; i=1
    for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
            t[i] = str
            i = i + 1
    end
    return t
end

_addon.helpText = function()
	text = "|c249382ChampionXP Slash Commands|r\n"..
				"|cD6660C/cxphelp|r - |c2dc50eDisplay slash commands|r\n"..
				"|cD6660C/cxp|r - |c2dc50eDisplay earned CXP (this session) and CXP/hr in chat|r\n"..
				"|cD6660C/cxpmove|r - |c2dc50eAllow movement of the window|r\n"..
				"|cD6660C/cxpreset|r - |c2dc50eReset the CXP session counter|r\n"..
				"|cD6660C/cxpver|r - |c2dc50eChampionXP version|r\n"
	return text
end

_addon.Initialize = function( self )
	self:UnregisterEvent( EVENT_ADD_ON_LOADED )
	LWF4.SILENCE = true
	EVENT_MANAGER:RegisterForEvent( _addon.Name, EVENT_PLAYER_ACTIVATED, self.PlayerActivated )
end

if ChampionXP == nil then ChampionXP = {} end
LWF4.REGISTER_FACTORY(
	_addon, false, true,
	function( self ) _addon:LoadSavedVariables( self ) end,
	function( self ) _addon:LoadSettingsMenu( self ) end,
	function( self ) _addon:Initialize( self ) end,
	"ChampionXP", true
)

SLASH_COMMANDS["/cxp"] = function()
	if lastCurXP == nil then lastCurXP = 0 end
	if lastCXPhr == nil then lastCXPhr = 0 end
	local text = "CXP earned: ".._addon:comma_value( lastCurXP ).." (avg: ".._addon:comma_value( lastCXPhr )..")"
	d( text )
end

SLASH_COMMANDS["/cxphelp"] = function()
	local text = _addon.helpText()
	d( text )
end

SLASH_COMMANDS["/cxpmove"] = function()
	_addon.moveWinActive = true
	d( "You can now move the CXP window" )
end

SLASH_COMMANDS["/cxpreset"] = function()
	cpxp = GetPlayerChampionXP()
	_addon.updateCPXPWin()
	d( "CXP counter for this session reset" )
end

SLASH_COMMANDS["/cxpver"] = function()
	d( _addon.Name.." v".._addon.Version.." by ".._addon.Author )
end
